package com.unipi.talepis.bscsofteng20244;

import java.util.concurrent.ThreadLocalRandom;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.function.Supplier;

public class Main {
    public static void main(String[] args) {
        printJob(new IPrint() {
            @Override
            public void printMe(String data) {
                System.out.println("Hi "+data);
            }
        });
        printJob(s-> System.out.println("Hello "+s));
        Supplier<Student> studentSupplier = new Supplier<Student>() {
            @Override
            public Student get() {
                int c = ThreadLocalRandom
                        .current()
                        .nextInt(1,300);
                return new Student("p23"+c);
            }
        };
        Student s1 = studentSupplier.get();
        Student s2 = studentSupplier.get();
        System.out.println(s1);
        System.out.println(s2);

        Consumer<Student> studentConsumer = new Consumer<Student>() {
            @Override
            public void accept(Student student) {
                System.out.println("I just consumed:"+student);
                //student.setAM("000");
            }
        };
        studentConsumer.accept(s1);
        //System.out.println(s1.getAM());
        Function<Student,String> studentAMFunction = new Function<Student, String>() {
            @Override
            public String apply(Student student) {
                return student.getAM();
            }
        };
        System.out.println(studentAMFunction.apply(s2));
        Predicate<Student> checkIfAMisValid = new Predicate<Student>() {
            @Override
            public boolean test(Student student) {
                return student.getAM().length()==6;
            }
        };
        System.out.println(checkIfAMisValid.test(s1));
        System.out.println(checkIfAMisValid.test(s2));

        MyEnum m1 = MyEnum.obj1;
        System.out.println(m1);

        MyRecord mr1 = new MyRecord("George","p21123","p@unipi.gr");
        System.out.println(mr1);
    }
    static void printJob(IPrint print){
        print.printMe("Unipi Java");
    }
}